   
    include \masm32\include\masm32rt.inc
    include \masm32\macros\macros.asm
    include \programming\Password\Data.asm

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib

    SetTextColor PROTO :DWORD,:DWORD
    SetScreenColor PROTO :DWORD,:DWORD
    WriteConsoleA PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

;**************************************************************************

.code

SetTextColor proc fore:DWORD,back:DWORD

    mov eax,back
    shl eax,4
    or  eax,fore
    invoke SetConsoleTextAttribute,hConsoleOutput,eax
    ret
    
SetTextColor endp

; -------------------------------------------------------------------------

SetScreenColor proc fore:DWORD,back:DWORD

    LOCAL noc    :DWORD
    LOCAL cnt    :DWORD
    LOCAL sbi    :CONSOLE_SCREEN_BUFFER_INFO

    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR sbi
    mov eax,sbi.dwSize
    push ax
    rol eax,16
    mov cx,ax
    pop ax
    mul cx
    cwde
    mov cnt,eax
    mov edx,back
    shl edx,4
    or  edx,fore
    invoke FillConsoleOutputAttribute,hConsoleOutput,edx,cnt,NULL,ADDR noc
    ret

SetScreenColor endp

; -------------------------------------------------------------------------

hidecursor:
    invoke GetConsoleCursorInfo,hConsoleOutput,addr cci
    mov cci.bVisible,FALSE
    invoke SetConsoleCursorInfo,hConsoleOutput,addr cci
    ret

; -------------------------------------------------------------------------

showcursor:
    invoke GetConsoleCursorInfo,hConsoleOutput,addr cci
    mov cci.bVisible,TRUE
    invoke SetConsoleCursorInfo,hConsoleOutput,addr cci
    ret

; -------------------------------------------------------------------------

blankline:                  ;clear bottom line (25 line display)
    loc 9,24                ;column 9 row 24
    invoke SetTextColor,black,black
    print "                                                              "
    ret

; -------------------------------------------------------------------------

sleepblank:
    invoke Sleep,1000       ;1 sec delay
    call blankline          ;remove message

canret:
    invoke SetTextColor,light_green,black
    loc 32,24
    print "Esc"
    invoke SetTextColor,light_magenta,black
    loc 26,24
    print "Press"
    loc 36,24
    print "To Cancel / Return"
    ret

; -------------------------------------------------------------------------

clearbottom:
    invoke SetTextColor,0,0
    mov edi,7               ;start at row 7 (8)
    mov count,16            ;16 rows

@@: inc edi                 ;next row
    push edi                ;save row
    loc 5,edi               ;column 4 & row n
    print "                                                                     "
    pop edi                 ;restore row
    dec count               ;row = row-1
    jne @B                  ;all done? no, loop again
    ret

;************************************************************************

start:
    call main
    exit

; *************************************************************************

main proc

    invoke GetStdHandle,STD_OUTPUT_HANDLE
    mov hConsoleOutput,eax
    invoke GetConsoleScreenBufferInfo,hConsoleOutput,ADDR csbi
    mov ax,25
    shl eax,16
    mov ax,csbi.dwSize.x
    invoke SetConsoleScreenBufferSize,hConsoleOutput,eax
    cld
    invoke SetConsoleTitle,addr consoletitle
    lea edi,sbuffer         ;point at save buffer
    mov wsbuffer,edi        ;store buffer pointer

restart:
    invoke SetScreenColor,black,black
    cls
    loc 30,3
    invoke SetTextColor,white,black
    print "PASSWORD GENERATOR"
    loc 19,14
    invoke SetTextColor,yellow,black
    print "Enter How Many Characters To Be Generated"
    loc 29,16
    invoke SetTextColor,white,black
    print "Minimum"
    invoke SetTextColor,light_red,black
    loc 37,16
    print "06"
    invoke SetTextColor,white,black
    loc 40,16
    print "Maximum"
    invoke SetTextColor,light_red,black
    loc 48,16
    print "18"
    invoke SetTextColor,yellow,black
    loc 31,18
    print "Then Press "
    invoke SetTextColor,light_green,black
    loc 42,18
    print "Enter"
    invoke SetTextColor,black,bright_white
    call showcursor
    loc 38,8
    print "  "              ;pseudo edit box
    mov numinput,0          ;clear digit counter
    lea edi,rbuffer         ;point at character number buffer
    mov workingbuffer,edi   ;save address
    mov ebx,37              ;column start

xp: inc ebx                 ;next column

xb: loc ebx,8
    getkey                  ;wait for & get keypress
    cmp al,8                ;Is it 'Backspace'?
    jne @F                  ;no, goto next key check
    cmp numinput,0          ;any digits input ?
    je xb                   ;no, ignore & return to keypress
    cmp numinput,2          ;2 digits input? i.e. no cursor
    jne jm                  ;no, cursor is present
    call showcursor         ;yes display cursor
    
jm: dec numinput            ;digits input = digits input-1
    dec workingbuffer       ;buffer pointer = buffer pointer-1
    dec ebx                 ;column = column-1
    loc ebx,8
    invoke SetTextColor,black,bright_white
    print " "               ;blank digit
    jmp xb                  ;return to keypress

@@: cmp al,13               ;is it 'Enter'?
    jne @F                  ;no, goto next key check
    cmp numinput,2          ;have 2 (legal) digits been input?
    je xh                   ;yes, exit routine
    jmp xb                  ;no, ignore & return to keypress

@@: cmp numinput,2          ;2 numbers already input?
    je xb                   ;yes, ignore & return to keypress
    cmp numinput,0          ;1st digit?
    jne @F                  ;no, goto 2nd digit check
    cmp al,"0"              ;1st digit
    jb xb                   ;can only
    cmp al,"1"              ;be zero
    ja xb                   ;or 1
    jmp xz                  ;goto accept digit

@@: cmp al,"0"              ;2nd digit
    jb xb                   ;must be in
    cmp al,"9"              ;the range
    ja xb                   ;zero to 9
    lea esi,rbuffer         ;point at buffer
    cmp BYTE PTR[esi],48    ;was 1st digit zero?
    jne @F                  ;no, must be 1
    cmp al,"6"              ;yes, 2nd digit
    jb xb                   ;cannot be < 6
    jmp xz                  ;goto accept digit

@@: cmp al,"8"              ;2nd digit
    ja xb                   ;cannot be > 8

xz: inc numinput            ;digit input = digit input+1
    mov edi,workingbuffer   ;get buffer
    stb                     ;store digit (ascii)
    sub al,48               ;change to binary
    mov workingbuffer,edi   ;save buffer pointer
    print udb$ (al)         ;display digit
    cmp numinput,2          ;2 digits input
    jne xp                  ;no, goto next column & keypress
    call hidecursor         ;yes, cursor no longer required
    jmp xp                  ;goto next column & keypress (Backspace?)

xh: invoke SetTextColor,black,black
    loc 38,8
    print "  "
    lea esi,rbuffer         ;point at buffer
    mov ax,[esi]            ;get number of characters (ascii)
    and ah,15               ;convert
    and al,15               ;number
    mov bh,ah               ;of characters
    mul ten                 ;to
    add al,bh               ;binary
    movzx eax,al
    mov randcount,eax       ;prime counter n characters
    mov randcountb,eax      ;save count for other routines
    lea esi,dsaddress-6     ;column address less minimum
    add esi,eax             ;calculate column
    movzx eax,BYTE PTR[esi] ;get column
    mov colpos,eax          ;save column
    mov colposb,eax         ;save column for later use

random2:
    call clearbottom
    call canret

; 
; *************************** Random Generator ****************************
; 

random:
    mov savflag,0           ;reset Password saved flag
    invoke SetTextColor,yellow,black
    loc 21,17
    print "Hold Down Spacebar To Generate Password"
    invoke SetTextColor,light_cyan,black
    mov count,63            ;prime character counter
    lea esi,ata             ;Point at characters
    mov ecx,62              ;62 characters to move
    lea edi,randombuffer    ;Move characters into
    rep movsb               ;working buffer
    lea edi,extnbuffer      ;random character save buffer
    push edi                ;save extnbuffer

@@: lea esi,randombuffer-1  ;point at working buffer
    mov ebx,count           ;prime character counter
    
r3: inc esi                 ;Next number
    dec ebx                 ;Count = count-1
    jz @B                   ;All done? yes, restart
    invoke GetAsyncKeyState,VK_ESCAPE
    test eax,00000000000000001000000000000000b
    jz @F
    pop edi                 ;balance stack
    jmp restart             ;goto main menu

@@: invoke GetAsyncKeyState,VK_SPACE
    test eax,1
    jz r3
    invoke GetAsyncKeyState,VK_SPACE
    test eax,00000000000000001000000000000000b
    jz r3
    dec count               ;Yes, count = count-1
    dec ebx                 ;character counter = character counter-1
    jne @F                  ;no, carry on
    inc ebx                 ;yes, adjust counter
    
@@: mov ecx,ebx             ;Prime loop counter
    push esi                ;save randombuffer pointer
    mov edi,esi             ;Prepare for block move
    lob                     ;Get selected character
    cmp al,0                ;end of sequence?
    jz r3                   ;yes, loop again
    rep movsb               ;Move all characters above down 1 place
    pop esi                 ;restore randombuffer
    pop edi                 ;restore extnbuffer
    mov ebp,edi             ;save address
    stb                     ;Save character in extnbuffer & inc pointer
    push edi                ;save extnbuffer
    sub esi,2               ;move character pointer back 2
    push esi                ;save character pointer
    mov esi,ebp             ;restore extnbuffer
    mov al,[esi]            ;character to display
    mov sdp,al              ;put in display $ 
    push ebx                ;save character counter
    mov ebx,colpos          ;previous cursor position
    add ebx,4               ;next position
    mov colpos,ebx          ;save position
    loc ebx,8               ;set display position
    invoke WriteConsoleA, hConsoleOutput, ADDR sdp, 1, ADDR written, NULL
    pop ebx                 ;restore character counter
    pop esi                 ;restore character pointer
    dec randcount           ;characters to select = characters to select-1
    jnz r3                  ;all selected? no, loop again
    pop edi                 ;balance stack
    loc 21,17
    print "                                       "

redis:
    invoke SetTextColor,light_green,black
    loc 28,13
    print "1"
    loc 28,15
    print "2"
    loc 28,17
    print "3"
    loc 28,19
    print "4"
    invoke SetTextColor,yellow,black
    loc 30,13
    print "- Another Password"
    loc 30,15
    print "- Save Password"
    loc 30,17
    print "- View Saved Passwords"
    loc 30,19
    print "- Clear Saved Passwords"

kpress: 
    getkey                  ;wait for & get keypress

SWITCH eax

    case "1"                ;another password?
        mov eax,colposb     ;get original column
        mov colpos,eax      ;prime working column
        mov eax,randcountb  ;get number of characters
        mov randcount,eax   ;prime character count
        jmp random2         ;yes, goto random generator

    case "2"                ;save numbers?
        jmp snum            ;yes, goto save characters

    case "3"                ;view saved characters?
        cmp storednum,0     ;any password
        jne showsaved       ;yes, display them
        
    @@: call blankline
        invoke SetTextColor,light_red,black
        loc 30,24           ;column 30 row 24
        print "NO PASSWORDS SAVED"
        call sleepblank     ;1 sec delay then blank message
        jmp kpress

    case "4"                ;clear saved passwords?
        cmp storednum,0     ;any saved?
        je @B               ;no, goto error
        mov storednum,0     ;yes, clear stored counter
        call blankline
        invoke SetTextColor,light_green,black
        loc 29,24           ;column 29 row 24
        print "PASSWORDS CLEARED"
        call sleepblank     ;1 sec delay then blank message
        jmp kpress

    case 27                 ;Esc?
        jmp restart         ;yes, goto restart

DEFAULT
        jmp kpress          ;illegal key, return to keypress

ENDSW

; 
; **************************** Save Numbers *******************************
; 

snum:
    call blankline
    cmp savflag,0           ;is Password already saved?
    je @F                   ;no, goto save
    invoke SetTextColor,light_red,black
    loc 27,24               ;column 29 row 24
    print "PASSWORD ALREADY SAVED"
    call sleepblank         ;1 sec delay then blank message
    jmp kpress              ;return to keypress

@@: cmp storednum,12        ;is limit reached?
    jne saveit              ;no, goto save set
    invoke SetTextColor,light_red,black
    loc 34,24               ;column 34 row 24
    print "BUFFER FULL"
    call sleepblank         ;1 sec delay then blank message
    jmp kpress              ;return to keypress

saveit:
    mov savflag,1           ;indicate current Password saved
    inc storednum           ;stored Passwords = stored Passwords+1
    mov edi,wsbuffer        ;point at save buffer
    lea esi,extnbuffer      ;point at Password to save
    mov ecx,randcountb      ;n characters to save
    mov [edi],ecx           ;save character count
    add edi,4               ;bypass count
    rep movsb               ;move characters into save buffer
    mov wsbuffer,edi        ;save buffer address
    invoke SetTextColor,light_green,black
    loc 31,24               ;column 32 row 24
    print "PASSWORD SAVED"
    call sleepblank         ;1 sec delay then blank message
    jmp kpress              ;return to keypress

; -------------------------------------------------------------------------

showsaved:
    invoke SetScreenColor,black,black
    cls                     ;clear display to all black
    call canret
    invoke SetTextColor,light_cyan,0
    lea esi,sbuffer         ;point at save buffer
    mov edx,storednum       ;prime passwords saved counter
    mov ebx,4               ;start at 5th row1   
    
as: mov edi,1               ;column position
    mov ecx,[esi]           ;n characters per set
    add esi,4               ;bypass count
    inc ebx                 ;next row down

sc: add edi,4               ;next column
    push edx                ;save Passwords saved counter
    push ecx                ;save character count
    loc edi,ebx
    mov al,[esi]            ;get character
    inc esi                 ;point at next character
    mov sdp,al              ;put in display $
    invoke WriteConsoleA, hConsoleOutput, ADDR sdp, 1, ADDR written, NULL
    pop ecx                 ;restore character count
    pop edx                 ;restore password count
    dec ecx                 ;characters = characters-1
    jne sc                  ;all done? no, loop for next
    dec edx                 ;sets of saved Passwords = sets of saved Passwords-1
    jne as                  ;all done? no, loop for next
      
@@: getkey                  ;wait for & get keypress
    cmp al,27               ;Is it Esc?
    jne @B                  ;no, ignore & return to keypress
    cls                     ;clear display to all black
    loc 30,3
    invoke SetTextColor,white,black
    print "PASSWORD GENERATOR"
    call canret
    invoke SetTextColor,light_cyan,black
    mov ebx,colposb         ;get original column
    mov colpos,ebx          ;prime working column
    mov ecx,randcountb      ;prime character count
    lea esi,extnbuffer      ;point at character buffer

@@: push ecx                ;save character count
    add ebx,4               ;next column
    loc ebx,8
    lob                     ;get character & inc pointer
    mov sdp,al              ;put in display $
    invoke WriteConsoleA, hConsoleOutput, ADDR sdp, 1, ADDR written, NULL
    pop ecx                 ;restore character count
    dec ecx                 ;characters = characters-1
    jne @B                  ;all done? no, loop again
    jmp redis               ;yes, return to menu
;**************************************************************************

main endp

end start